<?php
$db = new PDO('sqlite:./CraftFleet.db');

function searchGetItems($db, $name){
    if (!$name) return;
    $sql = "SELECT * FROM GetItems WHERE ItemName LIKE ('%".$name."%') order by Type, means";
    $result = $db->query($sql);
    if (!$result) return;
    return $result;
}

function searchGetAllItems($db, $name){
    if (!$name) return;
    $sql = "SELECT DISTINCT ItemName FROM GetItems order by Type, ItemName";
    $result = $db->query($sql);
    if (!$result) return;
    return $result;
}

function searchTypeItems($db, $type){
    if (!$type) return;
    $sql = "SELECT * FROM Items where Type = '".$type."' order by Rank, ID";
    $result = $db->query($sql);
    if (!$result) return;
    return $result;
}

function searchItems($db, $name){
    if (!$name) return;
    $sql = "SELECT * FROM Items where ItemName = '".$name."'";
    foreach($db->query($sql) as $row){
        return $row;
    }
}

function searchRecipe($db, $name){
    if (!$name) return;
    $sql = "SELECT * FROM Recipe WHERE CraftItem = '".$name."'";
    $result = $db->query($sql);
    if (!$result) return;
    return $result;
}

function searchRecipeReverseLookup($db, $name){
    if (!$name) return;
    $sql = "SELECT * FROM Recipe WHERE MaterialName = '".$name."'";
    $result = $db->query($sql);
    if (!$result) return;
    return $result;
}

function listMissionSkill($db, $sub){
    if (!$sub) {
        $sql = "SELECT distinct MSkill FROM Items ORDER BY MSkill";
    } else {
        $sql = "SELECT distinct MSkill FROM Items WHERE Rank = '".$sub."' ORDER BY MSkill";
    }
    $result = $db->query($sql);
    if (!$result) return;
    return $result;
}

function listFleetSkill($db, $sub){
    if (!$sub) {
        $sql = "SELECT distinct BSkill FROM Items ORDER BY BSkill";
    } else {
        $sql = "SELECT distinct BSkill FROM Items WHERE Rank = '".$sub."' ORDER BY BSkill";
    }
    $result = $db->query($sql);
    if (!$result) return;
    return $result;
}

function searchMissionSkillReverseLookup($db, $name){
    if (!$name) return;
    $sql = "SELECT * FROM Items WHERE MSkill = '".$name."'";
    $result = $db->query($sql);
    if (!$result) return;
    return $result;
}

function searchFleetSkillReverseLookup($db, $name){
    if (!$name) return;
    $sql = "SELECT * FROM Items WHERE BSkill = '".$name."'";
    $result = $db->query($sql);
    if (!$result) return;
    return $result;
}

function listMission($db){
    $sql = "SELECT DISTINCT means FROM GetItems WHERE TYPE = 1 ORDER BY CASE substr(means, 1, 1) WHEN 'ミ' THEN 1 WHEN '月' THEN 2 WHEN '火' THEN 3 WHEN '水' THEN 4 WHEN '木' THEN 5 WHEN '金' THEN 6 ELSE 7 END, 1";
    $result = $db->query($sql);
    if (!$result) return;
    return $result;
}

function searchMeanReverseLookup($db, $name){
    if (!$name) return;
    $sql = "SELECT * FROM GetItems a, Items b WHERE a.ItemName = b.ItemName and a.means = '".$name."' ORDER BY b.Rank, b.ID";
    $result = $db->query($sql);
    if (!$result) return;
    return $result;
}

function listBlueprint($db){
    $sql = "SELECT DISTINCT means FROM GetItems WHERE TYPE = 2 ORDER BY 1";
    $result = $db->query($sql);
    if (!$result) return;
    return $result;
}

function searchSkillKeyword($db, $colname, $type){
    $sql = "SELECT DISTINCT ".$colname." FROM ItemsKeyword WHERE TYPE = '".$type."' AND ".$colname." NOT IN('', '？') ORDER BY 1";
    $result = $db->query($sql);
    if (!$result) return;
    return $result;
}

function searchSkillReverseLookup($db, $type, $head, $middle, $bottom){
    if (!$type) return;
    $sql = "SELECT a.* FROM Items a, ItemsKeyword b WHERE a.ItemName = b.ItemName AND b.Type = '".$type."'";
    if ($head <> '') $sql = $sql." AND Head = '".$head."'";
    if ($middle <> '') $sql = $sql." AND Middle = '".$middle."'";
    if ($bottom <> '') $sql = $sql." AND Bottom = '".$bottom."'";
    $result = $db->query($sql);
    if (!$result) return;
    return $result;
}

?>

<html>
<head>
  <title>天空のクラフトフリート アイテム検索</title>
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes">
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
  <link rel="stylesheet" href="main2.css" type="text/css" media="all">
  <link media="only screen and (max-device-width:480px)" href="main.css" type="text/css" rel="stylesheet"/>
</head>
<body>
天空のクラフトフリート アイテム検索<br>
<a href="index.php?nm=head"     ><img src="img/head.jpg" alt="head"></a>
<a href="index.php?nm=top"      ><img src="img/top.jpg" alt="top"></a>
<a href="index.php?nm=body"     ><img src="img/body.jpg" alt="body"></a>
<a href="index.php?nm=bottom"   ><img src="img/bottom.jpg" alt="bottom"></a>
<a href="index.php?nm=side"     ><img src="img/side.jpg" alt="side"></a>
<a href="index.php?nm=blueprint"><img src="img/blueprint.jpg" alt="設計図"></a><br>
<a href="index.php?nm=skill">スキル一覧</a>
<a href="index.php?nm=mission">ミッション一覧</a>
<a href="index.php?nm=skillsearch">スキル検索</a>
<dl class="tb">
<?php
function is_mobile() {
$useragents = array(
'iPhone', // Apple iPhone
'iPod', // Apple iPod touch
'Android', // 1.5+ Android
'dream', // Pre 1.5 Android
'CUPCAKE', // 1.5+ Android
'blackberry9500', // Storm
'blackberry9530', // Storm
'blackberry9520', // Storm v2
'blackberry9550', // Storm v2
'blackberry9800', // Torch
'webOS', // Palm Pre Experimental
'incognito', // Other iPhone browser
'webmate' // Other iPhone browser
);
$pattern = '/'.implode('|', $useragents).'/i';
return preg_match($pattern, $_SERVER['HTTP_USER_AGENT']);
}

function appendH3($title, $mark = ""){
    echo sprintf("<h3>%s&nbsp;</h3>\r\n", $title);
}

function appendHead($title, $mark = ""){
    echo sprintf("<dt class=\"tb\">%s&nbsp;</dt>\r\n", $title);
}

function appendData($data, $mark = ""){
    echo sprintf("<dd class=\"tb\">%s%s&nbsp;</dd>\r\n", $data, $mark);
}

function appendLinkData($data, $data2, $data3 = "", $mark = ""){
    echo sprintf("<dd class=\"tb\"><a href=\"index.php?nm=%s\">%s</a>%s%s&nbsp;</dd>\r\n", urlencode($data), $data2, $data3, $mark);
}

function appendLinkModeData($data, $mode, $data2, $data3 = "", $mark = ""){
    echo sprintf("<dd class=\"tb\"><a href=\"index.php?nm=%s&mode=%s\">%s</a>%s%s&nbsp;</dd>\r\n", urlencode($data), urlencode($mode), $data2, $data3, $mark);
}

function convCode2Type($code){
    $type = "";
    switch($code){
    case "1":
        $type = 'HEAD';
        break;
    case "2":
        $type = 'TOP';
        break;
    case "3":
        $type = 'BODY';
        break;
    case "4":
        $type = 'BOTTOM';
        break;
    case "5":
        $type = 'SIDE';
        break;
    }
    return $type;
}

function drawRecipe($db, $name){
    $recipes = searchRecipe($db, htmlspecialchars($name, ENT_QUOTES));
    $recipe = $recipes->fetch(PDO::FETCH_ASSOC);
    if (!$recipe) return;
    appendH3('生産');
    appendHead("生産 Lv".$recipe['Lv']);
    appendLinkData($recipe['MaterialName'], $recipe['MaterialName'], ":".$recipe['MaterialNum']);
    while($recipe = $recipes->fetch(PDO::FETCH_ASSOC)){
        appendLinkData($recipe['MaterialName'], $recipe['MaterialName'], ":".$recipe['MaterialNum']);
    }
}

function drawRecipeReverseLookup($db, $name){
    $recipes = searchRecipeReverseLookup($db, htmlspecialchars($name, ENT_QUOTES));
    $recipe = $recipes->fetch(PDO::FETCH_ASSOC);
    if (!$recipe) return;
    appendH3('生産逆引き');
    appendHead("生産 Lv".$recipe['Lv']);
    appendLinkData($recipe['CraftItem'], $recipe['CraftItem'], ":".$recipe['MaterialNum']);
    while($recipe = $recipes->fetch(PDO::FETCH_ASSOC)){
        appendHead("生産 Lv".$recipe['Lv']);
        appendLinkData($recipe['CraftItem'], $recipe['CraftItem'], ":".$recipe['MaterialNum']);
    }
}

function drawRecipeTree($db, $name){
    appendH3('生産ツリー カッコ内は合計');
    echo "<ul class='tree'>\n";
    echo "<li>".$name."\n";
    drawRecipeTreeChild($db, $name,1,1);
    echo "</li>\n";
    echo "</ul>\n";
}

function drawRecipeTreeChild($db, $name, $treeLv, $needNum){
    $recipes = searchRecipe($db, htmlspecialchars($name, ENT_QUOTES));
    echo "<ul>";
    while($recipe = $recipes->fetch(PDO::FETCH_ASSOC)){
        if (!$recipe) {echo "</ul>"; return;}
        echo sprintf("<li><a href=\"index.php?nm=%s\">%s</a>%s\n", urlencode($recipe['MaterialName']), $recipe['MaterialName'], ":".$recipe['MaterialNum']." (".intval($recipe['MaterialNum']) * $needNum.")");
        drawRecipeTreeChild($db, $recipe['MaterialName'], $treeLv + 1, intval($recipe['MaterialNum']));
        echo "</li>\n";
    }
    echo "</ul>";
}

function drawSelectSkillList($db, $name, $skilltype, $selected_value = "") {
    $rows = searchSkillKeyword($db, $name, $skilltype);
    
    echo "<select name='".$name."'>";
    echo "<option value=''></option>";
    while($row = $rows->fetch(PDO::FETCH_ASSOC)) {
        if (!$row) {echo "</select>"; return;}
        echo "<option ";
        if ($selected_value == urlencode($row[$name])) {
            echo " selected ";
        }
        echo " value='".urlencode($row[$name])."'>".$row[$name]."</option>";
    }
    echo "</select>";
}

$poststr = htmlspecialchars($_GET['nm'], ENT_QUOTES);
$postsub = htmlspecialchars($_GET['sub'], ENT_QUOTES);
$mode = htmlspecialchars($_GET['mode'], ENT_QUOTES);
$rows = "";
if (!$mode) $mode = 0;

switch($poststr){
case "head":
    appendH3('HEAD一覧');
    $rows = searchTypeItems($db, 1);
    $mode = 1;
    break;
case "top":
    appendH3('TOP一覧');
    $rows = searchTypeItems($db, 2);
    $mode = 1;
    break;
case "body":
    appendH3('BODY一覧');
    $rows = searchTypeItems($db, 3);
    $mode = 1;
    break;
case "bottom":
    appendH3('BOTTOM一覧');
    $rows = searchTypeItems($db, 4);
    $mode = 1;
    break;
case "side":
    appendH3('SIDE一覧');
    $rows = searchTypeItems($db, 5);
    $mode = 1;
    break;
case "blueprint":
    $mode = 7;
    break;
case "skill":
    $mode = 2;
    break;
case "mission":
    $mode = 5;
    break;
case "skillsearch":
    $mode = 9;
    break;
}

if ($mode == 1){
    while($row = $rows->fetch(PDO::FETCH_ASSOC)){
        appendHead("☆".$row['Rank']);
        appendLinkData($row['ItemName'], $row['ItemName']);
    }
}else if ($mode == 2){
    echo'<a href="index.php?nm=skill">全て</a>
         <a href="index.php?nm=skill&sub=1">☆1</a>
         <a href="index.php?nm=skill&sub=2">☆2</a>
         <a href="index.php?nm=skill&sub=3">☆3</a>
         <a href="index.php?nm=skill&sub=4">☆4</a>';

    appendH3('スキル一覧');
    appendHead("ミッション");
    $rows = listMissionSkill($db, $postsub);
    while($row = $rows->fetch(PDO::FETCH_ASSOC)){
        appendLinkModeData($row['MSkill'], "3", $row['MSkill']);
    }
    appendHead("艦隊戦");
    $rows = listFleetSkill($db, $postsub);
    while($row = $rows->fetch(PDO::FETCH_ASSOC)){
        appendLinkModeData($row['BSkill'], "4", $row['BSkill']);
    }
}else if ($mode == 3){
    appendH3('ミッションスキル：'.$poststr);
    $rows = searchMissionSkillReverseLookup($db, $poststr);
    while($row = $rows->fetch(PDO::FETCH_ASSOC)){
        appendHead(convCode2Type($row['Type']));
        appendLinkData($row['ItemName'], "☆".$row['Rank']." ".$row['ItemName']);
    }
}else if ($mode == 4){
    appendH3('艦隊戦スキル：'.$poststr);
    $rows = searchFleetSkillReverseLookup($db, $poststr);
    while($row = $rows->fetch(PDO::FETCH_ASSOC)){
        appendHead(convCode2Type($row['Type']));
        appendLinkData($row['ItemName'], "☆".$row['Rank']." ".$row['ItemName']);
    }
}else if ($mode == 5){
    appendH3('ミッション一覧');
    appendHead("ミッション");
    $rows = listMission($db, $postsub);
    while($row = $rows->fetch(PDO::FETCH_ASSOC)){
        appendLinkModeData($row['means'], "6", $row['means']);
    }
}else if ($mode == 6){
    appendH3('ミッション：'.$poststr);
    $rows = searchMeanReverseLookup($db, $poststr);
    while($row = $rows->fetch(PDO::FETCH_ASSOC)){
        appendHead(convCode2Type($row['Type']));
        appendLinkData($row['ItemName'], "☆".$row['Rank']." ".$row['ItemName']);
    }
}else if ($mode == 7){
    appendH3('設計図コンプリート一覧');
    appendHead("設計図");
    $rows = listBlueprint($db, $postsub);
    while($row = $rows->fetch(PDO::FETCH_ASSOC)){
        appendLinkModeData($row['means'], "8", $row['means']);
    }
}else if ($mode == 8){
    appendH3('設計図：'.$poststr);
    $rows = searchMeanReverseLookup($db, $poststr);
    while($row = $rows->fetch(PDO::FETCH_ASSOC)){
        appendHead(convCode2Type($row['Type']));
        appendLinkData($row['ItemName'], "☆".$row['Rank']." ".$row['ItemName']);
    }
}else if ($mode == 9){
    $type   = htmlspecialchars($_GET['type'], ENT_QUOTES);
    $head   = htmlspecialchars($_GET['Head'], ENT_QUOTES);
    $middle = htmlspecialchars($_GET['Middle'], ENT_QUOTES);
    $bottom = htmlspecialchars($_GET['Bottom'], ENT_QUOTES);

    appendH3('スキル検索');
    echo "<form name='form1' method='get'>";
    echo "<input type='hidden' name='nm' value='skillsearch'>";
    echo "<select name='type'>";
    echo "<option ";
    if ($type == 'M' || !$type){
        echo 'selected';
    }
    echo " value='M'>ミッションスキル</option>";
    echo "<option ";
    if ($type != 'M'){
        echo 'selected';
    }
    echo " value='F'>艦隊戦スキル</option>";
    echo "</select>";
    echo "<input type='submit' name='exec2' value='変更'>";

    if ($type == "M"){
        $skilltype = "MSkill";
    } else {
        $skilltype = "BSkill";
    }
    
    echo "<br>";
    drawSelectSkillList($db, "Head", $skilltype, $head);
    echo "いつ<br>";
    drawSelectSkillList($db, "Middle", $skilltype, $middle);
    echo "なにが<br>";
    drawSelectSkillList($db, "Bottom", $skilltype, $bottom);
    echo "どうなる<br>";
    echo "<input type='submit' name='exec' value='検索'>";
    echo "</form>";
    if ($_REQUEST["exec"]){
        appendH3('結果');
        $rows = searchSkillReverseLookup($db, $skilltype, urldecode($head), urldecode($middle), urldecode($bottom));
        if (!$rows){
            echo "結果がありませんでした";
        }else{
            while($row = $rows->fetch(PDO::FETCH_ASSOC)){
                appendHead(convCode2Type($row['Type']));
                appendData($row[$skilltype]);
                appendLinkData($row['ItemName'], "☆".$row['Rank']." ".$row['ItemName']);
            }
        }
    }
    
}else{
    $rows = searchGetItems($db, $poststr);
    $item = searchItems($db, $poststr);

    if ($rows){
        appendH3("☆".$item['Rank']." ".$item['ItemName']);
        appendHead("部位");
        appendData(convCode2Type($item['Type']));
        appendHead("ﾐｯｼｮﾝｽｷﾙ");
        appendLinkModeData($item['MSkill'], "3", $item['MSkill']);
        appendHead("艦隊戦ｽｷﾙ");
        appendLinkModeData($item['BSkill'], "4", $item['BSkill']);
        appendHead("発動条件");
        appendData($item['SkillNeed']);
        $row = $rows->fetch(PDO::FETCH_ASSOC);
        if ($row){
            if($row['Type'] == 3){
                drawRecipe($db, $row['ItemName']);
            } else if($row['Type'] == 1){
                appendH3("ドロップ");
                appendLinkModeData($row['means'], "6", $row['means']);
            } else {
                appendH3("設計図コンプリート");
                appendLinkModeData($row['means'], "8", $row['means']);
            }
            while($row = $rows->fetch(PDO::FETCH_ASSOC)){
                if($row['Type'] == 3){
                    drawRecipe($db, $row['ItemName']);
                } else if($row['Type'] == 1){
                    appendH3("ドロップ");
                    appendLinkModeData($row['means'], "6", $row['means']);
                } else {
                    appendH3("設計図コンプリート");
                    appendLinkModeData($row['means'], "8", $row['means']);
                }
            }
        }

        drawRecipeReverseLookup($db, $_GET['nm']);

        drawRecipeTree($db, $_GET['nm']);
    }
}
?>
</dl>
<br><br><br>
<?php
if (!is_mobile()){
    echo "<a href='update.php'>データメンテナンス</a>";
}
?>
<br><br>
このサイトは次のサイトを応援しています。：<a href="http://tenkura.netgamers.jp/skill/">天クラ スキル逆引きキャラ検索（β）</a>
</body>
</html>
