<?php
$db = new PDO('sqlite:./CraftFleet.db');
session_start();

function selectItems($db){
    $sql = "SELECT * FROM Items order by 1,2,3";
    $result = $db->query($sql);
    if (!$result) return;
    return $result;
}

function selectRecipe($db){
    $sql = "SELECT * FROM Recipe order by 1,2,5";
    $result = $db->query($sql);
    if (!$result) return;
    return $result;
}

function selectGetItems($db){
    $sql = "SELECT * FROM GetItems order by 2,3,1";
    $result = $db->query($sql);
    if (!$result) return;
    return $result;
}

function selectEqualsItems($db, $data){
    if (!$data) return;
    $sql = "SELECT * FROM Items WHERE Type = '".$data[0]."' and Rank = '".$data[1]."' and ID = '".$data[2]."' and ItemName = '".$data[3]."' and MSkill = '".$data[4]."' and BSkill = '".$data[5]."' and SkillNeed = '".$data[6]."'";
    $result = $db->query($sql);
    if (!$result) return false;
    return true;
}

function selectEqualsRecipe($db, $data){
    if (!$data) return;
    $sql = "SELECT * FROM Recipe WHERE CraftType = '".$data[0]."' and CraftID = '".$data[1]."' and CraftItem = '".$data[2]."' and Lv = '".$data[3]."' and MaterialID = '".$data[4]."' and MaterialName = '".$data[5]."' and MaterialNum = '".$data[6]."'";
    $result = $db->query($sql);
    if (!$result) return false;
    return true;
}

function selectEqualsGetItems($db, $data){
    if (!$data) return;
    $sql = "SELECT * FROM GetItems WHERE ItemName = '".$data[0]."' and Type = '".$data[1]."' and means = '".$data[2]."'";
    $result = $db->query($sql);
    if (!$result) return false;
    return true;
}

function isDataTable($db, $table){
    if (!$table) return;
    $sql = "SELECT count(*) FROM ".$table;
    foreach($db->query($sql) as $row){
        return intval($row[0]);
    }
}

function truncateTable($db, $table){
    if (!$table) return;
    $sql = "DELETE FROM ".$table;
    $result = $db->query($sql);
    if (!$result) return false;
    return true;
}

function insertItems($db, $table, $data){
    if (!$data) return;
    if (!$table) return;
    $sql = "INSERT INTO ".$table." values(?, ?, ?, ?, ?, ?, ?)";
    $stmt = $db->prepare($sql);
    $result = $stmt->execute($data);
    return $result;
}

function insertRecipe($db, $table, $data){
    if (!$data) return;
    if (!$table) return;
    $sql = "INSERT INTO ".$table." values(?, ?, ?, ?, ?, ?, ?)";
    $stmt = $db->prepare($sql);
    $result = $stmt->execute($data);
    return $result;
}

function insertGetItems($db, $table, $data){
    if (!$data) return;
    if (!$table) return;
    $sql = "INSERT INTO ".$table." values(?, ?, ?)";
    $stmt = $db->prepare($sql);
    $result = $stmt->execute($data);
    return $result;
}
function selectDiffTable($db, $table){
    if (!$table) return;
    $sql = $sql."SELECT * FROM (SELECT '追加', * FROM ".$table."Work EXCEPT SELECT '追加', * FROM ".$table.")";
    $sql = $sql." union all ";
    $sql = $sql."SELECT * FROM (SELECT '削除', * FROM ".$table." EXCEPT SELECT '削除', * FROM ".$table."Work)";
    $result = $db->query($sql);
    return $result;
}

function isTimeoutWorkHistory($db){
    $sql = "SELECT count(*) FROM History WHERE datetime('now') < datetime(upddate, '+2 minutes') and updmode = 3";
    $result = $db->query($sql);
    foreach($db->query($sql) as $row){
        return intval($row[0] < 1);
    }
}

function getMaxHistoryID($db){
    $sql = "SELECT MAX(updid) FROM History";
    $result = $db->query($sql);
    foreach($db->query($sql) as $row){
        return intval($row[0]);
    }
}

function insertDataHistory($db, $table, $id){
    if (!$table) return;
    if (!$id) return;
    $sql = "INSERT INTO ".$table."History ";
    $sql = $sql."SELECT * FROM (SELECT ".$id.", 1, * FROM ".$table."Work EXCEPT SELECT ".$id.", 1, * FROM ".$table.")";
    $sql = $sql." union all ";
    $sql = $sql."SELECT * FROM (SELECT ".$id.", 2, * FROM ".$table." EXCEPT SELECT ".$id.", 2, * FROM ".$table."Work)";
    $result = $db->query($sql);
    return $result;
}

function insertWorkToData($db, $table){
    if (!$table) return;
    $sql = "INSERT INTO ".$table." SELECT * FROM ".$table."Work";
    $result = $db->query($sql);
    return $result;
}

function insertHistory($db, $id, $time, $mode){
    $sql = "INSERT INTO History values(?, ?, ?)";
    $stmt = $db->prepare($sql);
    $result = $stmt->execute(array($id, $time, $mode));
    return $result;
}


function drawList($db, $targetTable, $sep){
    $output = "";
    $rows = "";

    switch($targetTable){
    case "item":
        $rows = selectItems($db);
        $output = $output.'★タイプ'.$sep.'ランク'.$sep.'連番'.$sep.'アイテム名'.$sep.'ミッションスキル'.$sep.'艦隊戦スキル'.$sep.'発動条件'."\n";
        while($row = $rows->fetch(PDO::FETCH_ASSOC)){
            $output = $output.$row['Type'].$sep.$row['Rank'].$sep.$row['ID'].$sep.$row['ItemName'].$sep.$row['MSkill'].$sep.$row['BSkill'].$sep.$row['SkillNeed']."\n";
        }
        break;
    case "recipe":
        $rows = selectRecipe($db);
        $output = $output.'★タイプ'.$sep.'連番'.$sep.'製作アイテム名'.$sep.'必要レベル'.$sep.'材料連番'.$sep.'材料名'.$sep.'必要数'."\n";
        while($row = $rows->fetch(PDO::FETCH_ASSOC)){
            $output = $output.$row['CraftType'].$sep.$row['CraftID'].$sep.$row['CraftItem'].$sep.$row['Lv'].$sep.$row['MaterialID'].$sep.$row['MaterialName'].$sep.$row['MaterialNum']."\n";
        }
        break;
    case "get":
        $rows = selectGetItems($db);
        $output = $output.'★アイテム名'.$sep.'取得タイプ'.$sep.'取得方法'."\n";
        while($row = $rows->fetch(PDO::FETCH_ASSOC)){
            $output = $output.$row['ItemName'].$sep.$row['Type'].$sep.$row['means']."\n";
        }
        break;
    }

    echo "<input type='submit' name='getdata' value='取得'>";
    echo "<input type='submit' name='updatedata' value='確認'>";
    echo "<h3>出力結果</h3>";
    echo "<textarea name='tabledata' rows='50' cols='150'>".$output."</textarea>";
    echo getGuide($targetTable);
}

function getGuide($targetTable){
    switch($targetTable){
    case "item":
        $guide = '
<br><br>★の行は消さないでください
<dl class="tb">
<dt>タイプ<dd>1:HEAD<dd>2:TOP<dd>3:BODY<dd>4:BOTTOM<dd>5:SIDE<dd>6:設計図
<dt>ランク<dd>☆１～４の数字
<dt>連番<dd>同タイプ同ランク内のソート順
<dt>アイテム名<dd>アイテム名
<dt>ミッションスキル<dd>ミッションスキルの説明
<dt>艦隊戦スキル<dd>艦隊戦スキルの説明
<dt>発動条件<dd>発動条件
<dl>';
        break;
    case "recipe":
        $guide = '
<br><br>★の行は消さないでください
<dl class="tb">
<dt>タイプ<dd>1:HEAD<dd>2:TOP<dd>3:BODY<dd>4:BOTTOM<dd>5:SIDE
<dt>連番<dd>同タイプ内のソート順
<dt>製作アイテム名<dd>製作アイテム名
<dt>必要レベル<dd>制作に必要なレベル
<dt>材料連番<dd>ゲーム内の材料を左から連番を振ったもの
<dt>材料名<dd>材料のアイテム名
<dt>必要数<dd>材料の必要数
<dl>';
        break;
    case "get":
        $guide = '
<br><br>★の行は消さないでください
<dl class="tb">
<dt>アイテム名<dd>アイテム名
<dt>取得タイプ<dd>1:ミッションドロップ<dd>2:設計図コンプ<dd>3:アイテム作成
<dt>取得方法<dd>取得方法
<dl>';
        break;
    }
    return $guide;
}

function checkUpdate($db, $targetTable, $sep){
    $text = htmlspecialchars($_POST['tabledata'], ENT_QUOTES);
    $cr = array("\r\n", "\r");
    $text = trim($text);

    $text = str_replace($cr, "\n", $text);
    if (!$text){return "データがありません。";}
    mb_language("Japanese");
    mb_internal_encoding("UTF-8");
    if (mb_substr($text, 0, 1) != "★"){
        return "★付きの行がありません。";
    }

    $lines = explode("\n", $text);
    if (count($lines) <= 1){return "データがありません。";}

    $data = explode($sep, $lines[0]);
    if (trim($data[1]) != getCheckStr($targetTable)){
        return "更新テーブルと送信したデータが不一致です。";
    }
    
    $cnt = 0;
    $updateCnt = 0;
    foreach( $lines as $line ){
        if ($cnt == 0){$cnt++; continue;}

        $data = explode($sep, $line);
        array_walk($data, 'trim_value');

        if (count($data) != getCheckCount($targetTable)) {
            $error = $error.str_pad($cnt, 4, "0", STR_PAD_LEFT).":".$line."\tデータ数不正<br>";
        }

        $ret = checkRow($targetTable, $data, $cnt);
        if ($ret){
            $error = $error.$ret;
        }
        $cnt++;
    }
    if (!$error && checkWorkTable($db, $targetTable)){
        if (!isTimeoutWorkHistory($db)){
            $error = "他の方が同じテーブルの更新を行っています。最大で２分お待ちください。";
        } else {
            truncateWork($db, $targetTable);
        }
    }
    if (!$error){
        $cnt = 0;
        foreach( $lines as $line ){
            if ($cnt == 0){$header = $line; $cnt++; continue;}
            $data = explode($sep, $line);
            array_walk($data, 'trim_value');
            if (!setWorkTable($db, $targetTable, $data)){
                echo "想定外のデータベースエラー<br>";
            }
            $cnt++;
        }
        $diffs = getTableDiff($db, $targetTable);
        $diff = $diffs->fetch(PDO::FETCH_ASSOC);
        if (!$diff){
            $error = "データの変更がありませんでした";
            truncateWork($db, $targetTable);
        } else {
            $updid = getMaxHistoryID($db) + 1;
            $upddate = date(DATE_RFC3339);
            insertHistory($db, $updid, $upddate, 3);
            
            echo "<input type='submit' name='cancelgetdata' value='取得'>";
            echo "<input type='submit' name='updatemodifydata' value='修正確認'>";
            echo "<input type='submit' name='goupdate' value='登録'>";
            echo "<h3>差分確認</h3>";
            echo "問題なければ登録を押してください。";
            echo "<table class='table021'>";

            $data = explode($sep, $header);
            array_walk($data, 'trim_value');
            echo "<tr><th></th><th>".implode("</th><th>", $data )."</th></tr>\n";

            $tbtype = "";
            if ($diff["追加"] == "追加"){ $tbtype = "class='price'";}
            echo "<tr><td ".$tbtype.">".implode("</td><td ".$tbtype.">", $diff )."</td></tr>\n";

            while($diff = $diffs->fetch(PDO::FETCH_ASSOC)){
                $tbtype = "";
                if ($diff["追加"] == "追加"){ $tbtype = "class='price'";}
                echo "<tr><td ".$tbtype.">".implode("</td><td ".$tbtype.">", $diff )."</td></tr>\n";
            }
            echo "</table>";
            echo "<h3>出力結果</h3>";
            echo "<textarea name='tabledata' rows='50' cols='150'>".$text."</textarea>";
            echo getGuide($targetTable);
            $_SESSION["targetTable"] = $targetTable;
        }
    }
    if ($error){
        echo "<input type='submit' name='getdata' value='取得'>";
        echo "<input type='submit' name='updatedata' value='確認'>";
        echo "<h3>エラーがあります</h3>";
        echo "<pre>".$error."</pre>";
        echo "<h3>出力結果</h3>";
        echo "<textarea name='tabledata' rows='50' cols='150'>".$text."</textarea>";
        echo getGuide($targetTable);
    }
}

function updateData($db, $targetTable, $sep){

    $updid = getMaxHistoryID($db) + 1;
    $upddate = date(DATE_RFC3339);
    startUpdate($db, $targetTable, $updid, $upddate);
    session_destroy();
    echo "登録が完了しました";
}

function trim_value(&$value)
{
    $value = trim($value); 
}

function getCheckStr($targetTable){
    if($targetTable == "item"  ){ return "ランク"; }
    if($targetTable == "recipe"){ return "連番"; }
    if($targetTable == "get"   ){ return "取得タイプ"; }
    return "";
}

function getCheckCount($targetTable){
    if($targetTable == "item"  ){ return 7; }
    if($targetTable == "recipe"){ return 7; }
    if($targetTable == "get"   ){ return 3; }
    return "";
}

function checkRow($targetTable, $data, $cnt){
    if($targetTable == "item"  ){
        $ret = checkNum($data[0], $cnt); if ($ret){$error = $error.$ret;}
        $ret = checkNum($data[1], $cnt); if ($ret){$error = $error.$ret;}
        $ret = checkNum($data[2], $cnt); if ($ret){$error = $error.$ret;}
        $ret = checkStr($data[3],  60, $cnt); if ($ret){$error = $error.$ret;}
        $ret = checkStr($data[4], 300, $cnt); if ($ret){$error = $error.$ret;}
        $ret = checkStr($data[5], 300, $cnt); if ($ret){$error = $error.$ret;}
        $ret = checkStr($data[6],  60, $cnt); if ($ret){$error = $error.$ret;}
    }else if($targetTable == "recipe"){
        $ret = checkNum($data[0], $cnt); if ($ret){$error = $error.$ret;}
        $ret = checkNum($data[1], $cnt); if ($ret){$error = $error.$ret;}
        $ret = checkStr($data[2],  60, $cnt); if ($ret){$error = $error.$ret;}
        $ret = checkNum($data[3], $cnt); if ($ret){$error = $error.$ret;}
        $ret = checkNum($data[4], $cnt); if ($ret){$error = $error.$ret;}
        $ret = checkStr($data[5],  60, $cnt); if ($ret){$error = $error.$ret;}
        $ret = checkNum($data[6], $cnt); if ($ret){$error = $error.$ret;}
    }else if($targetTable == "get"   ){
        $ret = checkStr($data[0],  60, $cnt); if ($ret){$error = $error.$ret;}
        $ret = checkNum($data[1], $cnt); if ($ret){$error = $error.$ret;}
        $ret = checkStr($data[2],  60, $cnt); if ($ret){$error = $error.$ret;}
    }
    return $error;
}

function checkNum($checkval, $cnt){
    if (strlen($checkval) < 1){
        return $error.str_pad($cnt, 4, "0", STR_PAD_LEFT).":".$checkval."\t値無し<br>";
    }else if (is_numeric($checkval) == false){
        return $error.str_pad($cnt, 4, "0", STR_PAD_LEFT).":".$checkval."\t半角数値ではない<br>";
    }
    return false;
}

function checkStr($checkval,$checklen, $cnt){
    if (strlen($checkval) < 1){
        return $error.str_pad($cnt, 4, "0", STR_PAD_LEFT).":".$checkval."\t値無し<br>";
    }else if (strlen($checkval) > $checklen){
        return $error.str_pad($cnt, 4, "0", STR_PAD_LEFT).":".$checkval."\t文字数オーバー<br>";
    }
    return false;
}

function checkWorkTable($db, $targetTable){
    if($targetTable == "item"  ){
        return isDataTable($db, "ItemsWork");
    }else if($targetTable == "recipe"){
        return isDataTable($db, "RecipeWork");
    }else if($targetTable == "get"   ){
        return isDataTable($db, "GetItemsWork");
    }
    return true;
}

function truncateWork($db, $targetTable){
    if($targetTable == "item"  ){
        return truncateTable($db, "ItemsWork");
    }else if($targetTable == "recipe"){
        return truncateTable($db, "RecipeWork");
    }else if($targetTable == "get"   ){
        return truncateTable($db, "GetItemsWork");
    }
    return true;
}

function setWorkTable($db, $targetTable, $data){
    if($targetTable == "item"  ){
        return insertItems($db, "ItemsWork", $data);
    }else if($targetTable == "recipe"){
        return insertRecipe($db, "RecipeWork", $data);
    }else if($targetTable == "get"   ){
        return insertGetItems($db, "GetItemsWork", $data);
    }
    return true;
}

function getTableDiff($db, $targetTable){
    if($targetTable == "item"  ){
        return selectDiffTable($db, "Items");
    }else if($targetTable == "recipe"){
        return selectDiffTable($db, "Recipe");
    }else if($targetTable == "get"   ){
        return selectDiffTable($db, "GetItems");
    }
    return true;
}

function startUpdate($db, $targetTable, $updid, $upddate){
    insertHistory($db, $updid, $upddate, 1);
    if($targetTable == "item"  ){
        insertDataHistory($db, "Items", $updid);
        truncateTable($db, "Items");
        insertWorkToData($db, "Items");
        truncateTable($db, "ItemsWork");
        truncateTable($db, "ItemsKeyword");
        updateItemsKeyword($db, "MSkill");
        updateItemsKeyword($db, "BSkill");
    }else if($targetTable == "recipe"){
        insertDataHistory($db, "Recipe", $updid);
        truncateTable($db, "Recipe");
        insertWorkToData($db, "Recipe");
        truncateTable($db, "RecipeWork");
    }else if($targetTable == "get"   ){
        insertDataHistory($db, "GetItems", $updid);
        truncateTable($db, "GetItems");
        insertWorkToData($db, "GetItems");
        truncateTable($db, "GetItemsWork");
    }
    return true;
}

function updateItemsKeyword($db, $skillcol){
    $rows = searchSkillKeyword($db, $skillcol);
    while($row = $rows->fetch(PDO::FETCH_ASSOC)){
        $h = "";
        $m = "";

        $spl = explode("で", $row[$skillcol]);
        if (count($spl) > 1){
            $h = array_shift($spl)."で";
        }
        $spl = explode("時、", $spl[0]);
        if (count($spl) > 1){
            $h = array_shift($spl)."時、";
        }
        $spl = explode("が", $spl[0]);
        if (count($spl) > 1){
            $m = array_shift($spl)."が";
        }
        $b = $spl[0];
        insertItemsKeyword($db, $row["ItemName"], $skillcol, $h, $m, $b);
    }
}

function searchSkillKeyword($db, $skillcol){
    $sql = "SELECT ItemName, ".$skillcol." FROM Items";
    $result = $db->query($sql);
    if (!$result) return;
    return $result;
}

function insertItemsKeyword($db, $itemname, $skillcol, $head, $middle, $bottom){
    $sql = "INSERT INTO ItemsKeyword values(?, ?, ?, ?, ?)";
    $stmt = $db->prepare($sql);
    $result = $stmt->execute(array($itemname, $skillcol, $head, $middle, $bottom));
    return $result;
}


?>

<html>
<head>
  <title>天空のクラフトフリート アイテム検索 データメンテ</title>
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes">
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
  <link rel="stylesheet" href="main2.css" type="text/css" media="all">
  <link media="only screen and (max-device-width:480px)" href="main.css" type="text/css" rel="stylesheet"/>
</head>
<body>
<a href="./">戻る</a><br>
データメンテナンス<br>
<form name="form" action="./update.php" method="POST">
<h3>対象テーブル</h3>
<input name="table" type="radio" value="item" <?php if ($_REQUEST["table"] == 'item' || !$_REQUEST["table"]){echo 'checked';}?>>アイテム
<input name="table" type="radio" value="recipe" <?php if ($_REQUEST["table"] == 'recipe'){echo 'checked';}?>>レシピ
<input name="table" type="radio" value="get" <?php if ($_REQUEST["table"] == 'get'){echo 'checked';}?>>入手方法
<h3>区切り文字</h3>
<input name="sep" type="radio" value="comma" <?php if ($_REQUEST["sep"] == 'comma' || !$_REQUEST["sep"]){echo 'checked';}?>>カンマ
<input name="sep" type="radio" value="tab" <?php if ($_REQUEST["sep"] == 'tab'){echo 'checked';}?>>タブ
<br>
<?php
$targetTable = $_REQUEST["table"];
$selectSep = $_REQUEST["sep"];
$submitgetdata = $_REQUEST["getdata"];
$cancelgetdata = $_REQUEST["cancelgetdata"];
$submitupdatedata = $_REQUEST["updatedata"];
$updatemodifydata = $_REQUEST["updatemodifydata"];
$submitgoupdate = $_REQUEST["goupdate"];
$mode = 0;

if ($submitgetdata){
    $mode = 1;
} else if ($cancelgetdata){
    $mode = 5;
} else if ($submitupdatedata){
    $mode = 2;
} else if ($updatemodifydata){
    $mode = 3;
} else if ($submitgoupdate){
    $mode = 4;
}

$sep = ",";
switch($selectSep){
case "comma":
    $sep = ",";
    break;
case "tab":
    $sep = "\t";
    break;
}

if ($mode == 1 || $mode == 5){
    if ($mode == 5){truncateWork($db, $targetTable);}
    drawList($db, $targetTable, $sep);
} else if ($mode == 2 || $mode == 3){
    if ($mode == 3){truncateWork($db, $targetTable);}
    $ret = checkUpdate($db, $targetTable, $sep);
    if($ret){
        echo "<input type='submit' name='getdata' value='取得'>";
        echo "<input type='submit' name='updatedata' value='確認'>";
        echo "<h3>エラーがあります</h3>";
        echo "<pre>".$ret."</pre>";
        echo "<h3>出力結果</h3>";
        echo "<textarea name='tabledata' rows='50' cols='150'>".htmlspecialchars($_POST['tabledata'], ENT_QUOTES)."</textarea>";
        echo getGuide($targetTable);
    }
} else if ($mode == 4){
    updateData($db, $targetTable, $sep);
} else {
    echo "<input type='submit' name='getdata' value='取得'>";

    echo "<br><br><br><br><br><br><br><br>（アフィの代わり的な）招待コード「o5dt9ya0」<br>招待使ってない方、宜しければ入力して頂けるとありがたいです。";
    echo "<br><a href='src.zip'>ソース</a> <a href='CraftFleet.db'>DB(sqlite3)</a>";
}


?>
</form>
</body>
</html>
